//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 36


#property strict

//
//
//
//
//
input string              MainTermNote = "=== Main Settings ==";
extern ENUM_MA_METHOD     MaMode      = MODE_EMA;       // Average method
extern ENUM_APPLIED_PRICE MaPrice     = PRICE_CLOSE;    // Price

input string              ShortTermNote = "=== Short Term MA Settings ==";
input int                 ShortPeriod1 = 3;              // Short Ma period 1
input int                 ShortPeriod2 = 5;              // Short Ma period 2
input int                 ShortPeriod3 = 8;              // Short Ma period 3
input int                 ShortPeriod4 = 10;             // Short Ma period 4
input int                 ShortPeriod5 = 12;             // Short Ma period 5
input int                 ShortPeriod6 = 15;             // Short Ma period 6
extern color              Upcolor     = clrSpringGreen; // Bullish fast line  color
extern color              Dncolor     = clrCrimson;       // Bearish fast line  color
extern int                LineWidth   =   1;              // Slow Lines width
extern bool               ShowLines    = true;             // Slow lines are visible?



input string              LongTermNote = "=== Long Term MA Settings ==";
input int                 LongPeriod1 = 30;              // Long Ma period 1
input int                 LongPeriod2 = 35;              // Long Ma period 2
input int                 LongPeriod3 = 40;              // Long Ma period 3
input int                 LongPeriod4 = 45;              // Long Ma period 4
input int                 LongPeriod5 = 50;              // Long Ma period 5
input int                 LongPeriod6 = 60;              // Long Ma period 6
extern color              Upcolor2     = clrDodgerBlue; // Bullish fast line  color
extern color              Dncolor2     = clrMagenta;       // Bearish fast line  color
extern int                LineWidth2   =   2;              // Slow Lines width
extern bool               ShowLines2    = true;             // Slow lines are visible?


input string              ButtonTermNote = "=== Button Settings ==";
extern int                btn_Subwindow = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "guppy";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                            
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern string             btn_pressed           = "guppy OFF";            
extern string             btn_unpressed         = "guppy ON";
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 850;                                 
extern int                button_y              = 0;                                   
extern int                btn_Width             = 90;                                 
extern int                btn_Height            = 20;                                
extern string             soundBT               = "tick.wav";  


bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix ,buttonId ;

//
//
//
//
//

double ma[],mada[],madb[],slope[];
double ma2[],mada2[],madb2[],slope2[];
double ma3[],mada3[],madb3[],slope3[];
double ma4[],mada4[],madb4[],slope4[];
double ma5[],mada5[],madb5[],slope5[];

double ma6[],mada6[],madb6[],slope6[];
double ma7[],mada7[],madb7[],slope7[];
double ma8[],mada8[],madb8[],slope8[];
double ma9[],mada9[],madb9[],slope9[];
double ma10[],mada10[],madb10[],slope10[];

double ma11[],mada11[],madb11[],slope11[];
double ma12[],mada12[],madb12[],slope12[];
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}


int init()
{
   for (int i=0; i<indicator_buffers; i++) SetIndexStyle(i,DRAW_LINE);
    IndicatorBuffers(48);
   SetIndexBuffer(0,ma  ,INDICATOR_DATA); SetIndexStyle(0,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(1,mada,INDICATOR_DATA); SetIndexStyle(1,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(2,madb,INDICATOR_DATA); SetIndexStyle(2,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(3,ma2  ,INDICATOR_DATA); SetIndexStyle(3,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(4,mada2,INDICATOR_DATA); SetIndexStyle(4,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(5,madb2,INDICATOR_DATA); SetIndexStyle(5,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(6,ma3  ,INDICATOR_DATA); SetIndexStyle(6,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(7,mada3,INDICATOR_DATA); SetIndexStyle(7,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(8,madb3,INDICATOR_DATA); SetIndexStyle(8,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(9,ma4  ,INDICATOR_DATA); SetIndexStyle(9,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(10,mada4,INDICATOR_DATA); SetIndexStyle(10,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(11,madb4,INDICATOR_DATA); SetIndexStyle(11,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(12,ma5  ,INDICATOR_DATA); SetIndexStyle(12,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(13,mada5,INDICATOR_DATA); SetIndexStyle(13,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(14,madb5,INDICATOR_DATA); SetIndexStyle(14,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(15,ma6  ,INDICATOR_DATA); SetIndexStyle(15,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(16,mada6,INDICATOR_DATA); SetIndexStyle(16,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(17,madb6,INDICATOR_DATA); SetIndexStyle(17,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(18,ma7  ,INDICATOR_DATA); SetIndexStyle(18,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(19,mada7,INDICATOR_DATA); SetIndexStyle(19,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(20,madb7,INDICATOR_DATA); SetIndexStyle(20,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(21,ma8  ,INDICATOR_DATA); SetIndexStyle(21,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(22,mada8,INDICATOR_DATA); SetIndexStyle(22,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(23,madb8,INDICATOR_DATA); SetIndexStyle(23,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(24,ma9  ,INDICATOR_DATA); SetIndexStyle(24,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(25,mada9,INDICATOR_DATA); SetIndexStyle(25,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(26,madb9,INDICATOR_DATA); SetIndexStyle(26,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(27,ma10  ,INDICATOR_DATA); SetIndexStyle(27,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(28,mada10,INDICATOR_DATA); SetIndexStyle(28,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(29,madb10,INDICATOR_DATA); SetIndexStyle(29,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(30,ma11  ,INDICATOR_DATA); SetIndexStyle(30,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(31,mada11,INDICATOR_DATA); SetIndexStyle(31,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(32,madb11,INDICATOR_DATA); SetIndexStyle(32,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(33,ma12  ,INDICATOR_DATA); SetIndexStyle(33,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(34,mada12,INDICATOR_DATA); SetIndexStyle(34,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(35,madb12,INDICATOR_DATA); SetIndexStyle(35,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(36,slope);
   SetIndexBuffer(37,slope2); 
   SetIndexBuffer(38,slope3);
   SetIndexBuffer(39,slope4);
   SetIndexBuffer(40,slope5);
   SetIndexBuffer(41,slope6);
   SetIndexBuffer(42,slope7);
   SetIndexBuffer(43,slope8);
   SetIndexBuffer(44,slope9);
   SetIndexBuffer(45,slope10);
   SetIndexBuffer(46,slope11);
   SetIndexBuffer(47,slope12);
   
      //
      //
      //
      //
      //
     
       
       
   
    IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(WindowExpertName());
   IndicatorDigits(Digits);
      double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
   show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix+btn_text;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);
   
   
   return(0);
}

void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate (ChartID(),buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}


int deinit()
 {
 
  ObjectsDeleteAll(0,"guppy");
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
   
  return(0); 
  }     

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
bool recalc = true;
 void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
void OnChartEvent(const int id, 
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {
   if (soundBT!="") PlaySound(soundBT);     
   }
}
//
//

int start()
{
 handleButtonClicks();
   recalc = false;
   
   start2();
    SetIndexBuffer(0,ma  ,INDICATOR_DATA); SetIndexStyle(0,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(1,mada,INDICATOR_DATA); SetIndexStyle(1,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(2,madb,INDICATOR_DATA); SetIndexStyle(2,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(3,ma2  ,INDICATOR_DATA); SetIndexStyle(3,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(4,mada2,INDICATOR_DATA); SetIndexStyle(4,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(5,madb2,INDICATOR_DATA); SetIndexStyle(5,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(6,ma3  ,INDICATOR_DATA); SetIndexStyle(6,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(7,mada3,INDICATOR_DATA); SetIndexStyle(7,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(8,madb3,INDICATOR_DATA); SetIndexStyle(8,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(9,ma4  ,INDICATOR_DATA); SetIndexStyle(9,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(10,mada4,INDICATOR_DATA); SetIndexStyle(10,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(11,madb4,INDICATOR_DATA); SetIndexStyle(11,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(12,ma5  ,INDICATOR_DATA); SetIndexStyle(12,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(13,mada5,INDICATOR_DATA); SetIndexStyle(13,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(14,madb5,INDICATOR_DATA); SetIndexStyle(14,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(15,ma6  ,INDICATOR_DATA); SetIndexStyle(15,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Upcolor);
   SetIndexBuffer(16,mada6,INDICATOR_DATA); SetIndexStyle(16,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   SetIndexBuffer(17,madb6,INDICATOR_DATA); SetIndexStyle(17,ShowLines ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth,Dncolor);
   
   SetIndexBuffer(18,ma7  ,INDICATOR_DATA); SetIndexStyle(18,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(19,mada7,INDICATOR_DATA); SetIndexStyle(19,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(20,madb7,INDICATOR_DATA); SetIndexStyle(20,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(21,ma8  ,INDICATOR_DATA); SetIndexStyle(21,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(22,mada8,INDICATOR_DATA); SetIndexStyle(22,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(23,madb8,INDICATOR_DATA); SetIndexStyle(23,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(24,ma9  ,INDICATOR_DATA); SetIndexStyle(24,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(25,mada9,INDICATOR_DATA); SetIndexStyle(25,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(26,madb9,INDICATOR_DATA); SetIndexStyle(26,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(27,ma10  ,INDICATOR_DATA); SetIndexStyle(27,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(28,mada10,INDICATOR_DATA); SetIndexStyle(28,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(29,madb10,INDICATOR_DATA); SetIndexStyle(29,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(30,ma11  ,INDICATOR_DATA); SetIndexStyle(30,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(31,mada11,INDICATOR_DATA); SetIndexStyle(31,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(32,madb11,INDICATOR_DATA); SetIndexStyle(32,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   SetIndexBuffer(33,ma12  ,INDICATOR_DATA); SetIndexStyle(33,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Upcolor2);
   SetIndexBuffer(34,mada12,INDICATOR_DATA); SetIndexStyle(34,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   SetIndexBuffer(35,madb12,INDICATOR_DATA); SetIndexStyle(35,ShowLines2 ? DRAW_LINE :  DRAW_NONE,EMPTY,LineWidth2,Dncolor2);
   
   if (show_data)
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_unpressed);
      
      }
      else
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_pressed);
         for (int kvak = 0; kvak< 36; kvak++)
            SetIndexStyle(kvak,DRAW_NONE);
       
       
      
   
      //template code     
      }
       return(0);
      }
      
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start2()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int i,limit = fmin(Bars-counted_bars,Bars-1);
        
   //
   //
    if (slope[i]==-1) CleanPoint(limit,mada,madb);
    if (slope2[i]==-1) CleanPoint(limit,mada2,madb2);
    if (slope3[i]==-1) CleanPoint(limit,mada3,madb3);
    if (slope4[i]==-1) CleanPoint(limit,mada4,madb4);
    if (slope5[i]==-1) CleanPoint(limit,mada5,madb5);
    if (slope6[i]==-1) CleanPoint(limit,mada6,madb6);
    if (slope7[i]==-1) CleanPoint(limit,mada7,madb7);
    if (slope8[i]==-1) CleanPoint(limit,mada8,madb8);
    if (slope9[i]==-1) CleanPoint(limit,mada9,madb9);
    if (slope10[i]==-1) CleanPoint(limit,mada10,madb10);
    if (slope11[i]==-1) CleanPoint(limit,mada11,madb11);
    if (slope12[i]==-1) CleanPoint(limit,mada12,madb12);
   for ( i = limit; i >= 0 ; i--)
   {
       ma[i]    = iMA(NULL,0,ShortPeriod1,0,MaMode,MaPrice,i);
       ma2[i]   = iMA(NULL,0,ShortPeriod2,0,MaMode,MaPrice,i);
       ma3[i]   = iMA(NULL,0,ShortPeriod3,0,MaMode,MaPrice,i);
       ma4[i]   = iMA(NULL,0,ShortPeriod4,0,MaMode,MaPrice,i);
       ma5[i]   = iMA(NULL,0,ShortPeriod5,0,MaMode,MaPrice,i);
       ma6[i]   = iMA(NULL,0,ShortPeriod6,0,MaMode,MaPrice,i);
       
       ma7[i]    = iMA(NULL,0,LongPeriod1,0,MaMode,MaPrice,i);
       ma8[i]    = iMA(NULL,0,LongPeriod2,0,MaMode,MaPrice,i);
       ma9[i]    = iMA(NULL,0,LongPeriod3,0,MaMode,MaPrice,i);
       ma10[i]   = iMA(NULL,0,LongPeriod4,0,MaMode,MaPrice,i);
       ma11[i]   = iMA(NULL,0,LongPeriod5,0,MaMode,MaPrice,i);
       ma12[i]   = iMA(NULL,0,LongPeriod6,0,MaMode,MaPrice,i);
      
       mada[i] = madb[i] = EMPTY_VALUE; 
       mada2[i] = madb2[i] = EMPTY_VALUE;
       mada3[i] = madb3[i] = EMPTY_VALUE;            
       mada4[i] = madb4[i] = EMPTY_VALUE;
       mada5[i] = madb5[i] = EMPTY_VALUE;
       mada6[i] = madb6[i] = EMPTY_VALUE;  
       mada7[i] = madb7[i] = EMPTY_VALUE;   
       mada8[i] = madb8[i] = EMPTY_VALUE;  
       mada9[i] = madb9[i] = EMPTY_VALUE;  
       mada10[i] = madb10[i] = EMPTY_VALUE;  
       mada11[i] = madb11[i] = EMPTY_VALUE;  
       mada12[i] = madb12[i] = EMPTY_VALUE; 
        
      slope[i]   = (i<Bars-1) ? (ma[i]>ma[i+1])     ? 1 : (ma[i]<ma[i+1])     ? -1 : slope[i+1]   : 0;   
      slope2[i]  = (i<Bars-1) ? (ma2[i]>ma2[i+1])   ? 1 : (ma2[i]<ma2[i+1])   ? -1 : slope2[i+1]  : 0;  
      slope3[i]  = (i<Bars-1) ? (ma3[i]>ma3[i+1])   ? 1 : (ma3[i]<ma3[i+1])   ? -1 : slope3[i+1]  : 0;  
      slope4[i]  = (i<Bars-1) ? (ma4[i]>ma4[i+1])   ? 1 : (ma4[i]<ma4[i+1])   ? -1 : slope4[i+1]  : 0;   
      slope5[i]  = (i<Bars-1) ? (ma5[i]>ma5[i+1])   ? 1 : (ma5[i]<ma5[i+1])   ? -1 : slope5[i+1]  : 0;
      slope6[i]  = (i<Bars-1) ? (ma6[i]>ma6[i+1])   ? 1 : (ma6[i]<ma6[i+1])   ? -1 : slope6[i+1]  : 0;
      slope7[i]  = (i<Bars-1) ? (ma7[i]>ma7[i+1])   ? 1 : (ma7[i]<ma7[i+1])   ? -1 : slope7[i+1]  : 0;  
      slope8[i]  = (i<Bars-1) ? (ma8[i]>ma8[i+1])   ? 1 : (ma8[i]<ma8[i+1])   ? -1 : slope8[i+1]  : 0; 
      slope9[i]  = (i<Bars-1) ? (ma9[i]>ma9[i+1])   ? 1 : (ma9[i]<ma9[i+1])   ? -1 : slope9[i+1]  : 0; 
      slope10[i] = (i<Bars-1) ? (ma10[i]>ma10[i+1]) ? 1 : (ma10[i]<ma10[i+1]) ? -1 : slope10[i+1] : 0;  
      slope11[i] = (i<Bars-1) ? (ma11[i]>ma11[i+1]) ? 1 : (ma11[i]<ma11[i+1]) ? -1 : slope11[i+1] : 0; 
      slope12[i] = (i<Bars-1) ? (ma12[i]>ma12[i+1]) ? 1 : (ma12[i]<ma12[i+1]) ? -1 : slope12[i+1] : 0;               
      
      if (slope[i]==-1) PlotPoint(i,mada,madb,ma);
      if (slope2[i]==-1) PlotPoint(i,mada2,madb2,ma2);  
      if (slope3[i]==-1) PlotPoint(i,mada3,madb3,ma3);  
      if (slope4[i]==-1) PlotPoint(i,mada4,madb4,ma4);  
      if (slope5[i]==-1) PlotPoint(i,mada5,madb5,ma5);  
      if (slope6[i]==-1) PlotPoint(i,mada6,madb6,ma6); 
      if (slope7[i]==-1) PlotPoint(i,mada7,madb7,ma7);
      if (slope8[i]==-1) PlotPoint(i,mada8,madb8,ma8);   
      if (slope9[i]==-1) PlotPoint(i,mada9,madb9,ma9);  
      if (slope10[i]==-1) PlotPoint(i,mada10,madb10,ma10); 
      if (slope11[i]==-1) PlotPoint(i,mada11,madb11,ma11); 
      if (slope12[i]==-1) PlotPoint(i,mada12,madb12,ma12);  
       
       
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}
//
